<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfQueryTransaction-Response ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfQueryTransaction-Response
 * @subpackage Arrays
 */
class ArrayOfQueryTransaction_Response extends AbstractStructArrayBase
{
    /**
     * The QueryTransaction_Response
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\QueryTransaction_Response[]
     */
    public $QueryTransaction_Response;
    /**
     * Constructor method for ArrayOfQueryTransaction-Response
     * @uses ArrayOfQueryTransaction_Response::setQueryTransaction_Response()
     * @param \patest\StructType\QueryTransaction_Response[] $queryTransaction_Response
     */
    public function __construct(array $queryTransaction_Response = array())
    {
        $this
            ->setQueryTransaction_Response($queryTransaction_Response);
    }
    /**
     * Get QueryTransaction_Response value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\QueryTransaction_Response[]|null
     */
    public function getQueryTransaction_Response()
    {
        return isset($this->{'QueryTransaction-Response'}) ? $this->{'QueryTransaction-Response'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setQueryTransaction_Response method
     * This method is willingly generated in order to preserve the one-line inline validation within the setQueryTransaction_Response method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateQueryTransaction_ResponseForArrayConstraintsFromSetQueryTransaction_Response(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfQueryTransaction_ResponseQueryTransaction_ResponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfQueryTransaction_ResponseQueryTransaction_ResponseItem instanceof \patest\StructType\QueryTransaction_Response) {
                $invalidValues[] = is_object($arrayOfQueryTransaction_ResponseQueryTransaction_ResponseItem) ? get_class($arrayOfQueryTransaction_ResponseQueryTransaction_ResponseItem) : sprintf('%s(%s)', gettype($arrayOfQueryTransaction_ResponseQueryTransaction_ResponseItem), var_export($arrayOfQueryTransaction_ResponseQueryTransaction_ResponseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The QueryTransaction_Response property can only contain items of type \patest\StructType\QueryTransaction_Response, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set QueryTransaction_Response value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\QueryTransaction_Response[] $queryTransaction_Response
     * @return \patest\ArrayType\ArrayOfQueryTransaction_Response
     */
    public function setQueryTransaction_Response(array $queryTransaction_Response = array())
    {
        // validation for constraint: array
        if ('' !== ($queryTransaction_ResponseArrayErrorMessage = self::validateQueryTransaction_ResponseForArrayConstraintsFromSetQueryTransaction_Response($queryTransaction_Response))) {
            throw new \InvalidArgumentException($queryTransaction_ResponseArrayErrorMessage, __LINE__);
        }
        if (is_null($queryTransaction_Response) || (is_array($queryTransaction_Response) && empty($queryTransaction_Response))) {
            unset($this->QueryTransaction_Response, $this->{'QueryTransaction-Response'});
        } else {
            $this->QueryTransaction_Response = $this->{'QueryTransaction-Response'} = $queryTransaction_Response;
        }
        return $this;
    }
    /**
     * Add item to QueryTransaction_Response value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\QueryTransaction_Response $item
     * @return \patest\ArrayType\ArrayOfQueryTransaction_Response
     */
    public function addToQueryTransaction_Response(\patest\StructType\QueryTransaction_Response $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\QueryTransaction_Response) {
            throw new \InvalidArgumentException(sprintf('The QueryTransaction_Response property can only contain items of type \patest\StructType\QueryTransaction_Response, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->QueryTransaction_Response[] = $this->{'QueryTransaction-Response'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\QueryTransaction_Response|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\QueryTransaction_Response|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\QueryTransaction_Response|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\QueryTransaction_Response|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\QueryTransaction_Response|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string QueryTransaction-Response
     */
    public function getAttributeName()
    {
        return 'QueryTransaction-Response';
    }
}
